from tkinter import *
import random,math,time
def array(N1, N2=0,N3=0):   #■配列宣言
    if N2==0: return [0 for i in range(N1)]
    if N3==0: return [[0 for i in range(N2)]
                      for j in range(N1)]
    return[[[0 for i in range(N3)]for j in range(N2)]
           for k in range(N1)]
NUM=30            # 個体数
XY=array(2,NUM,2) # XY座標
for i in range(NUM):
    XY[0][i][0]=random.random()*400
    XY[0][i][1]=random.random()*400
VL=array(NUM,2)   # 速度
def aveXY(XY):#■値の平均
    X=0;Y=0;N=len(XY)
    for i in range(N):X+=XY[i][0];Y+=XY[i][1]
    return [X/N, Y/N]
def keepPace(XY,beta=0.1):#■平均位置方向への加速度計算
    global NUM
    AC=array(NUM,2)
    R=aveXY(XY);XC=R[0];YC=R[1]; i2=1-i1
    for i in range(len(XY)):
        AC[i][0]=(XC-XY[i][0])*beta
        AC[i][1]=(YC-XY[i][1])*beta
    return AC
def CohesionAndAlignment(i1):#■結合と整列
    global XY,VL
    AC1=keepPace(XY[i1],0.1)#Cohesion(結合)    
    AC2=keepPace(VL,0.1)#Alignment(整列)
    for i in range(NUM):
        VL[i][0]= VL[i][0]+DT*(AC1[i][0]+AC2[i][0])
        VL[i][1]= VL[i][1]+DT*(AC1[i][1]+AC2[i][1])
def Levy():#■レヴィー分布関数
    x=random.random()*6
    if abs(x)<0.00001:return 0
    c=0.5; A=math.sqrt(c/(2*math.pi))
    return A*math.exp(-c/(2*x))/(math.pow(x,1.5))
def RandomWalk(walk=0):#■ランダム・ウォーク
    global VL # walk=0: isotropic walk, walk=1: Levy walk(flight)
    for i in range(NUM):
        TH=random.random()*2*math.pi
        if walk==0: DH=20  # isotropic walk
        else: DH=Levy()*50 # Levy walkisotropic walk
        VL[i][0]=DH*math.cos(TH)
        VL[i][1]=DH*math.sin(TH)
def updXY(i1,DT):#■座標変更
    global XY,VL; i2=1-i1
    for i in range(NUM):
        XY[i2][i][0]= XY[i1][i][0]+DT*VL[i][0]
        XY[i2][i][1]= XY[i1][i][1]+DT*VL[i][1]
def underR(DX):#■距離が1より近いときの
    if DX>=0:return 1  #便宜的なDXの値設定
    return -1
def Seperation(i1,DT):#■分離
    global XY,VL
    i2=1-i1
    for i in range(NUM):
        for j in range(NUM):
            if i!=j:
                DX=XY[i2][j][0]-XY[i2][i][0]
                DY=XY[i2][j][1]-XY[i2][i][1]
                R=math.sqrt(DX*DX+DY*DY)
                if R<10:#距離が10より近いとき分離処理
                    if R<1: R=1;DX=underR(DX);DY=underR(DY)
                    XY[i2][j][0]=XY[i2][i][0]+DX*10/R
                    XY[i2][j][1]=XY[i2][i][1]+DY*10/R
def pV(V):#■負の値を0以上にする
    X=V
    while X<0: X+=400
    return X
def mV(V):#■400以上の値を400未満にする
    X=V
    while X>399: X-=400
    return X
def drawXY(canvas,XY):#■Boidsの位置描画
    N=len(XY)
    for i in range(NUM):
        X=mV(pV(XY[i][0]))+10
        Y=mV(pV(XY[i][1]))+10
        canvas.create_oval(X, Y, X+3,Y+3, fill="red",tag="DT")
#-----------(メインプログラム)---------------
root=Tk();root.title("Bird oid")
canvas=Canvas(root,width=420,height=440,bg="white")
canvas.pack();root.update()
x0=200.0; y0=200.0;i2=0;DT=0.1
for k in range(20000):
    i1=i2; i2=1-i1
    canvas.delete("DT")
    drawXY(canvas,XY[i1])
    root.update()
    time.sleep(0.01)
    RandomWalk(walk=1)      #ランダム・ウォーク
    CohesionAndAlignment(i1)#結合と整列
    updXY(i1,DT)            #座標変更
    Seperation(i1,DT)       #分離
    


    


